package bcho.tracer.logging.simplelogger;

import bcho.tracer.aspectj.aspects.Context;
import bcho.tracer.logging.Logger;
import bcho.tracer.logging.LoggingUnit;

public class TextLogger implements Logger {

	public void logEnd(LoggingUnit unit) {
		// TODO Auto-generated method stub
		log("E",unit.getLocalTransactionId()
				,unit.getTransactionId()
				,unit.getEndTime()
				,unit.getSignature().getDeclaringType().getName()+":"+unit.getSignature().getName()
				,"("+(unit.getEndCpuTime()-unit.getStartCpuTime())+"ns/"
				+ (unit.getEndTime()-unit.getStartTime())+"ms)");

	}

	public void logStart(LoggingUnit unit) {
		// TODO Auto-generated method stub
		log("S",unit.getLocalTransactionId()
				,unit.getTransactionId()
				,unit.getStartTime()
				,unit.getSignature().getDeclaringType().getName()+":"+unit.getSignature().getName()
				,"");
	}
	
	public void logStartGlobalTransaction(String txId){
		txlog(true,txId);
	}
	public void logEndGlobalTransaction(String txId){
		txlog(false,txId);
	}	
	protected void log(String status,String localTxId
			,String txId,long time
			,String signature,String detail)
	{
		int depth = Context.depth();
		System.out.print("TRACE("+depth+")");
		for(int i=0;i<depth;i++) System.out.print("  ");
		System.out.println(status+" "+txId+":"+localTxId+" "+time+"ns : "+signature+" "+detail);
	}

	
	protected void txlog(boolean isStart,String txId){
		String buf="";
		if(isStart){
			buf="START TRANSACTION :";
		}else{
			buf="END TRANSACTION :";
		}
		buf = buf + txId;
		System.out.println(buf);
	}

}
